/* $Id: batch.h,v 2.5 1993/05/28 22:15:01 klute Exp klute $ */

/* 
 * Copyright 1993 Rainer Klute <klute@irb.informatik.uni-dortmund.de>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation. The author makes no representations about the suitability
 * of this software for any purpose. It is provided "as is" without express
 * or implied warranty.
 *
 */

#include <stdio.h>

#include "utils.h"
#include "xplz.h"


#if !defined (BATCH_H)
#define BATCH_H

typedef struct Batch
{
    char *inputFile;
    char *outputFile;
    char *errorFile;
    char separator;
    int  columnStreet;
    int  columnPlz;
    int  columnPlace;
    enum {OutputISO, OutputIBM, OutputAtari} outputFormat;
    FILE *ifl;
    FILE *ofl;
    FILE *efl;
    enum {BatchInit, BatchRunning, BatchInterrupted, BatchFinished, BatchError}
	 status;
    char *inputRecord;
    PlzConversion *pc;
    Boolean fehlerAnhalten;
    void (*failureCallback)(struct Batch *);
    void (*successCallback)(struct Batch *);
    void (*beforeConvertCallback)(struct Batch *, char *strasse,
				  char *hausnummer, char *postfach,
				  char *plz_alt, char *ort, char *postanstalt,
				  char *ortsteil);
    void (*afterConvertCallback)(struct Batch *);
    void (*finishedCallback)(struct Batch *);
    void *userData;
}
Batch;

extern Boolean BatchConvert (Batch *batch);

#endif
